<div dir="rtl">

## [ایران استاک](https://github.com/J-Yaghoubi/iran_stock) 

+ [آشنایی](#این-برنامه-چه-کاری-انجام-می-دهد) 
+ [نصب](#چگونه-آن-را-نصب-کنیم)    
+ [استفاده](#چگونه-از-آن-استفاده-کنیم)
+ [وابستگی ها](#عملکرد-برنامه-به-چه-ابزارهای-جانبی-وابسته-است)        


## این برنامه چه کاری انجام می دهد

این ابزار به سایت tsetmc.com متصل شده و اطلاعات نمادهای موجود در بازار سهام ایران را اعم از اطلاعات قیمتی و پارامترهای بنیادی دریافت و در قالب دیتافریم در اختیار کاربران قرار می دهد.     
در پیاده سازی و کدنویسی سعی ما بر این بوده که ابزار را به گونه ای طراحی کنیم که کاربر را از هرگونه پیچیدگی به دور نگه داشته و سهولت استفاده را فراهم کند. طبعا سعی ما بر این است که با حفظ همین استراتژی و به مرور زمان با توجه به نیاز کاربران به گسترش قابلیت ها و امکانات این ابزار پرداخته و در بروزرسانی هایی که 
انجام می دهیم در مسیر پیشرفت و تکمیل پروژه گام برداریم.
        

## چگونه آن را نصب کنیم

برای نصب ایران-استاک کافی است که کد زیر را در مفسر پایتون خود وارد کنید تا ابزار از طریق منبع پایتون دریافت و در سیستم شما نصب شود:

<div>

<div dir="ltr">

```bash
pip install iran_stock
```

<div>


<div dir="rtl">

## چگونه از آن استفاده کنیم

1. دریافت سابقه قیمتی    
------------------------
برای دریافت سابقه قیمت ها کافی است تا نماد فارسی سهم و یا کداختصاری انگلیسی آن را در دستور زیر وارد کنید:

<div>

<div dir="ltr">

```python
import ir_stock as tse
data = tse.get('شبندر')
```

<div>

 
<div dir="rtl">

اگر تمایل دارید در زمان واحد سابقه قیمتی لیستی از چندین سهم مختلف را دریافت کنید لازم است تا نام نمادهای مورد نظر خود را درون یک لیست قرار داده و سپس لیست را به عنوان آرگومان به تابع get وارد کنید.   

<div>

<div dir="ltr">

```python
import ir_stock as tse
tickers = ['شبندر', 'ملت', 'فملی']
data = tse.get(tickers)
```
<div>

<div dir="rtl">

در هنگام دریافت اطلاعات چه در مواردی که در حال دریافت اطلاعات تک سهم هستید و چه در مواقعی که لیستی از سهم ها را برای دانلود انتخاب کرده اید، این امکان وجود دارد که محدوده داده را با کمک تعیین تاریخ شروع و پایان مشخص کنید:

<div>

<div dir="ltr">

```python
import ir_stock as tse
tickers = ['شبندر', 'ملت', 'فملی']
data = tse.get(tickers, start='2018-01-20', end='2022-01-01')
```
<div>

<div dir="rtl">

در هنگام دریافت اطلاعات به این نکته توجه داشته باشید که سایت tsetmc دسترسی پکیج پانداس را محدود کرده و در بسیاری از موارد اجازه نمی دهد داده ها را به صورت مستقیم از طریق این پکیج دریافت کنیم. برای رفع این مشکل ابزار ایران-استاک ابتدا داده ها را به صورت خام دریافت و در قالب یک فایل ذخیره می کند. سپس فایل ذخیره شده را بازخوانی کرده و به صورت دیتافریم پانداس در اختیار کاربر قرار می دهد.

<div>


<div dir="rtl">

2. دریافت اطلاعات بنیادی    
------------------------
برای دریافت اطلاعات بنیادی کافی است تا نماد فارسی سهم و یا کداختصاری انگلیسی آن را در دستور زیر وارد کنید:

<div>

<div dir="ltr">

```python
import ir_stock as tse
data = tse.fund('شبندر')
```

<div>

<div dir="rtl">

اگر تمایل دارید در زمان واحد اطلاعات بنیادی لیستی از چندین سهم مختلف را دریافت کنید لازم است تا نام نمادهای مورد نظر خود را درون یک لیست قرار داده و سپس لیست را به عنوان آرگومان به تابع fund وارد کنید:   

<div>

<div dir="ltr">

```python
import ir_stock as tse
tickers = ['شبندر', 'ملت', 'فملی']
data = tse.fund(tickers)
```
<div>

<div dir="rtl">

<div dir="rtl">

بعد از اینکه اطلاعات بنیادی سهم و یا لیستی از سهم ها را دریافت کردیم می توانید به همه اطلاعات دریافتی به صورت یکجا و یا به تک تک مولفه ها به صورت مجزا دسترسی داشته باشید. اگر می خواهیم تمام داده دریافتی را به صورت یکجا مشاهده کنید کافی است تا محتویات متغیر را چاپ کنید:  

<div>

<div dir="ltr">

```python
print(data)
```
<div>

<div dir="rtl">

و اما برای دسترسی مجزا به مولفه های دریافتی و چاپ آن ها می توانید مانند مثال زیر عمل کنید:

<div>

<div dir="ltr">

```python
print(data.title)
print(data.group)
print(data.evg_volume)
print(data.eps)
print(data.pe)
print(data.sector_pe)
print(data.base_volume)
print(data.shares)
print(data.nav)
```
<div>

<div dir="rtl">

3. کار با بانک اطلاعاتی    
------------------------
جهت تسریع در خوانش اطلاعات و جستجوی لینک نمادهای درخواستی، ایران-استاک از یک پایگاه داده استفاده می کند که در آن لیست تمام نمادهای موجود در بازار بورس و اوراق بهادار ایران ذخیره شده است. هنگامی که برای اولین بار ایران-استاک را به کار می برید،
داده های لازم دریافت و این پایگاه داده ساخته می شود.    
این بانک اطلاعاتی قابلیت بروزرسانی را نیز دارد و اگر نماد جدیدی در بازار سهام درج شود، می تواند خود را با آخرین تغییرات منطبق کند. برای بروزرسانی محتوای پایگاه داده کافی است تا از دستور زیر کمک بگیرید:

<div>

<div dir="ltr">

```python
import ir_stock as tse
tse.update()
```

<div>


<div dir="rtl">

اگر مایل هستید از اطلاعات ذخیره شده در این بانک اطلاعاتی مطلع شوید، دستور زیر به شما کمک خواهد کرد:    

<div>

<div dir="ltr">

```python
import ir_stock as tse
data = tse.check()
print(db)
```

<div>


<div dir="rtl">

4. کمی بیشتر   
------------------------
اگر احساس می کنید توضیحاتی که تا اینجا در مورد چگونگی کار با ایران-استاک داده شده است، برای آشنایی با نحوه کار آن کافی نیست، می توانید به پوشه مثال ها مراجعه کرده و نمونه های بیشتری از نحوه کار با این ماژول را مشاهده کنید.

<div>


<div dir="rtl">

## عملکرد برنامه به چه ابزارهای جانبی وابسته است

ایران-استاک برای اینکه بتواند به وظایف خود به درستی عمل کند نیاز دارد تا ابزارهای زیر نیز در سیستم شما نصب شده باشند. البته نیاز نیست شخصا به نصب آن ها اقدام کنید زیرا هنگام نصب ایران-استاک همگی به صورت خودکار نصب خواهند شد:

<div>

<div dir="ltr">

+ [BeautifulSoup](https://pypi.org/project/beautifulsoup4)        
+ [Requests](https://pypi.org/project/requests/)        
+ [Pandas](https://pypi.org/project/pandas/)

<div>
        
        




